#include "idpsswdcontainer.h"

IdpsswdContainer::IdpsswdContainer(QObject *parent, bool cycle) : QObject(parent), _cycle(cycle), _index(0), _size(0)
{
}

IdpsswdContainer::~IdpsswdContainer()
{
}

void IdpsswdContainer::addIdpw(QString id, QString psswd)
{
	_set.push_back(qMakePair(id, psswd));
	_size++;
}

QString IdpsswdContainer::id()
{
	if(_index < _size)
	{
		return _set[_index].first;
	}
	else
	{
		qDebug() << "ERROR : All accounts have been depleted";
		qApp->exit(1);

//		emit error();
		return "";
	}
}

QString IdpsswdContainer::psswd()
{
	if(_index < _size)
	{
		return _set[_index].second;
	}
	else
	{
		qDebug() << "ERROR : All accounts have been depleted";
		qApp->exit(1);

//		emit error();
		return "";
	}
}

int IdpsswdContainer::index()
{
	return _index;
}

void IdpsswdContainer::next()
{
	_index++;
	if(_index == _size)
	{
		if(_cycle)
		{
			_index = 0;
			emit depleted();
		}
		else
		{
//			emit error();
		}
	}
	else
	{
		emit depleted();
	}
}
