#ifndef IDPSSWDCONTAINER_H
#define IDPSSWDCONTAINER_H

#include <QDebug>
#include <QApplication>

#include <QPair>
#include <QVector>

typedef QPair<QString,QString> Idpsswd;
typedef QVector<Idpsswd> IdpsswdSet;

class IdpsswdContainer : public QObject
{
		Q_OBJECT

	public:
		IdpsswdContainer(QObject *parent = 0, bool cycle = false);
		~IdpsswdContainer();

		void addIdpw(QString id, QString psswd);
		QString id();
		QString psswd();
		int index();
		void next();

	signals:
		void error();
		void depleted();

	private:
		bool _cycle;
		int _index;
		int _size;

		IdpsswdSet _set;
};

#endif // IDPSSWDCONTAINER_H
