#ifndef APIDATASIFT_H
#define APIDATASIFT_H

#include <QtNetwork>

#include <qjson/parser.h>

#include "../graph/graph.h"
#include "../manager/setting.h"


class StreamUpdater : public QObject
{
		Q_OBJECT

	public:
		StreamUpdater(QObject *parent);
		~StreamUpdater();

		void getRequest(QNetworkRequest request);

		QNetworkReply *reply;

	private slots:
		void requestHandler();

	signals:
		void requestReady(StreamUpdater *);

	private:
		QNetworkAccessManager *_manager;

};

class ApiDatasift : public QObject
{
		Q_OBJECT

	public:
		ApiDatasift(Graph **graph, Setting *settings);
		ApiDatasift(QObject *parent, Graph **graph, Setting *settings);
		~ApiDatasift();

		void setHash(QString hash);
		void setCsdl(QString csdl);

		int tweetNumber();

//	signals:
//		void errorSignal();
//		void handledSignal();

	public slots:
		void refresh();
		void refreshHandler(StreamUpdater *streamupdater);
		void csdlHandler(StreamUpdater *streamupdater);

	signals:
		void getFriends(int);

	private:
		QNetworkRequest streamRequest();
		QNetworkRequest csdlRequest(QString & csdl);

//		void errorDisplay(QString errorStr);

		int _tweetNumber;
		bool _refreshing;

		QString _interactionId;
		QString _hash;
		QString _csdl;

		Graph **_graph_ptr;

		Setting *_settings;
};





#endif // APIDATASIFT_H
