#ifndef APITWITTER_H
#define APITWITTER_H

//#include <QtGui>

#include <QInputDialog>
#include <QDesktopServices>

#include <QThreadPool>
#include <QRunnable>

#include <QSettings>
#include <QtOAuth/QtOAuth>
#include <QtNetwork>

#include "qjson/parser.h"

#include "../graph/graph.h"
#include "../manager/setting.h"

#define CONSUMER_KEY "zvmnzdXrPH4pvx3MgzaqQ"
#define CONSUMER_SECRET_KEY "jH54O5hJGwLYifx2U177cq4GyjfZUOiFBJ79KUlyPg"


class TokenFetcher : public QWidget
{
		Q_OBJECT

	public:
		explicit TokenFetcher(QWidget *parent = 0);
		~TokenFetcher();
		void getAccess();

	signals:
		void gotAccess(QString, QString, QString);

	private:
		QOAuth::Interface *oauthInterface;
		QNetworkAccessManager *manager;
		QByteArray token;
		QByteArray tokenSecret;
};


class FriendsFetcher : public QObject
{
		Q_OBJECT

	public:
		explicit FriendsFetcher(QObject *parent = NULL);
		~FriendsFetcher();

		void run(int id, QString cursor, QString token, QString tokenSecret, int tokenId);

		QNetworkReply *reply;
		int id;
		QString cursor;
		int tokenId;

	private:
		QOAuth::Interface *_oauthInterface;
		QNetworkAccessManager *_manager;
};


class FriendRunnable : public QObject, public QRunnable
{
		Q_OBJECT

	public:
		FriendRunnable(int id, QString cursor, Setting *settings);
		void run();

	signals:
		void gotReply(FriendsFetcher *friendsFetcher);

	private:

		int _id;
		QString _cursor;
		Setting *_settings;
};

class ApiTwitter : public QWidget
{
		Q_OBJECT

	public:
		explicit ApiTwitter(Graph **graph_ptr, Setting *settings);
		explicit ApiTwitter(QWidget *parent, Graph **graph_ptr, Setting *settings);
		~ApiTwitter();

	public slots:
		void run();
		void friendsHandler(FriendsFetcher*);
		void updateFollowers(int id, QString cursor = "-1");

	private:		
		Graph **_graph_ptr;
		Setting *_settings;

		QThreadPool *_threadPool;
};




#endif // APITWITTER_H
