#ifndef APITWITTER2_H
#define APITWITTER2_H


#include <QtNetwork>
#include <QSettings>
#include <QtKOAuth>

#include <qjson/parser.h>

#include "../graph/graph.h"
#include "../manager/setting.h"

#define CONSUMER_KEY "zvmnzdXrPH4pvx3MgzaqQ"
#define CONSUMER_SECRET_KEY "jH54O5hJGwLYifx2U177cq4GyjfZUOiFBJ79KUlyPg"

class TokenFetcher : public QObject
{
	Q_OBJECT

	public:
		TokenFetcher(QObject *parent=0);
		~TokenFetcher();
		void getAccess();

	signals:
		void accessTokenReceived(QString token, QString tokenSecret);

	private slots:
		void onTemporaryTokenReceived(QString temporaryToken, QString temporaryTokenSecret);
		void onAuthorizationReceived(QString token, QString verifier);
		void onAccessTokenReceived(QString token, QString tokenSecret);

	private:
		KQOAuthManager * _oauthManager;
		KQOAuthRequest * _oauthRequest;
};

struct TwitterUpdater : public QWidget
{
	Q_OBJECT

	public:
		TwitterUpdater(QWidget *parent = 0);
		~TwitterUpdater();

		void getFriends(int id, int cursor, QString token, QString tokenSecret, int tokenId);

		QByteArray response;

	signals:
		void gotFriends(TwitterUpdater *);

	public slots:
		void responseHandler(QByteArray response);

	private:
		KQOAuthManager * oauthManager;
		KQOAuthRequest * oauthRequest;

		int _id;
		int _cursor;
		int _tokenId;
};

class ApiTwitter : public QWidget
{
	Q_OBJECT

	public:
		ApiTwitter(Graph **graph_ptr, Setting *settings);
		ApiTwitter(QWidget *parent, Graph **graph_ptr, Setting *settings);

	public slots:
		void run();
		void handleFriends(TwitterUpdater *updater);

	private:
		bool _refreshing;

		Graph **_graph_ptr;
		Setting *_settings;
};



#endif // APITWITTER2_H
