#ifndef TIMER_H
#define TIMER_H

#include <QtGui>
#include <QTime>
#include <QTimer>
#include <QVector>

int timeToMs(QTime time, int day = 0);

class Timer : public QTimer
{
	Q_OBJECT

	public:
		Timer(QObject *parent, int runtime, QObject *target, const char *method, bool single);
		Timer(QObject *parent, int runtime, QObject *target, const char *method, const char *method_error, bool single);

	public slots:
		void launch();

	private:
		int _time;
		bool _singleShot;
};

class TimerManager : public QObject
{
	Q_OBJECT

	public:
		explicit TimerManager(QObject *parent =0);
		~TimerManager();
		void addTimer(int runtime, QObject *target, const char *method, bool single = false);
		void addTimer(int runtime, QObject *target, const char *method, const char *method_error, bool single = false);

	public slots:
		void start();
		void stop();
		void error();

	signals:
		void errorSignal();

	private:
		QVector<Timer*> _timerVect;

};


#endif // TIMER_H
