#ifndef RUNWINDOW_H
#define RUNWINDOW_H

#include <QDialog>
#include <QtGui>

#include "wait.h"

#include "../manager/setting.h"

#include "../graph/graph.h"
#include "../time/timer.h"
#include "../network/apidatasift.h"
#include "../network/apitwitter.h"
//#include "../network/apitwitter2.h"


namespace Ui {
	class RunWindow;
}

class RunWindow : public QDialog
{
		Q_OBJECT
		
	public:
		explicit RunWindow(Setting *settings);
		explicit RunWindow(QWidget *parent, Setting *settings);
		~RunWindow();

	private slots:
		void on_runningCancel_pushButton_clicked();

	public slots:
		void stop();
		void updateBar();
		void updateInfo();

	private:
		void launch();

		Ui::RunWindow *ui;

		TimerManager *timer;
		Graph *graph;
		ApiTwitter *apitwitter;
		ApiDatasift *apidatasift;

		Setting *settings;

};

#endif // RUNWINDOW_H
